#include "hge.h"
#include "hgeresource.h"
#include "hgesprite.h"
#include "hgeanim.h"
#include "hgefont.h"
#include "tile.h"
#include "map.h"
#include "fmod.hpp"
#include "player.h"
#include "time.h"
#include "string"
#include "fstream"

using namespace std;

HGE *hge = NULL;

hgeQuad quad;

Map *TileMap;
FMOD::System *ssystem;
FMOD::Channel *channel;
Player P;
hgeFont *font;
char buffer[10];
int TotalTime = 0;

float deathtime = 1000;
float livetime = 1000;

int bombs_awarded = 0;
int high_score = 0;
char high_score_a[100];
ifstream file;
ofstream file2;

bool new_score = false;
bool first_run = true;


bool FrameFunc()
{
	float dt=hge->Timer_GetDelta()*1000;  //get the time since the last call to FrameFunc
	//float dt = 1000;
	if(P.GetStatus() == true)
	{
		if(first_run == false)
		{
			TotalTime += dt;

			livetime -= dt;
			if(livetime < 0)
				livetime = 0;
		}
	}
	else
		deathtime += dt;

	if(TotalTime > high_score)
	{
		high_score = TotalTime;
		new_score = true;
	}

	ssystem->update();

	
	P.Update(dt, TileMap);
	int count = TileMap->GetPlayerCount();
	TileMap->Update(dt, ssystem, channel);
	int count2 = TileMap->GetPlayerCount();
	P.GetInput(hge,TileMap, dt);

	if(first_run == true)
	{

		if(hge->Input_GetKeyState(HGEK_ENTER))
		{

			TileMap->Reset();
			TileMap->AddPlayer(7, 2);
			P.SetAlive(true);	
			P.ResetBombs();
			TotalTime = 0;
			bombs_awarded = 0;
			TileMap->UpdateOn();
			first_run = false;

		}

	}

	if(P.GetStatus() == false)
	{
		if(TotalTime > high_score)
		{
		high_score = TotalTime;
		new_score = true;
		}
		if(new_score == true)
		{
			file2.open("score.txt");
			  file2<<itoa(high_score,buffer,10);
			  file2.close();
			new_score = false;
		}

		TileMap->UpdateOff();

		if(hge->Input_GetKeyState(HGEK_ENTER))
		{

			TileMap->Reset();
			TileMap->AddPlayer(7, 2);
			P.SetAlive(true);	
			P.ResetBombs();
			TotalTime = 0;
			bombs_awarded = 0;
			TileMap->UpdateOn();
			livetime = 1000.0;

		}
	}

	if((TotalTime - bombs_awarded*90000) > 90000)
	{
		P.AddBomb();
		bombs_awarded++;
	}

	

	hge->Gfx_BeginScene();
	hge->Gfx_Clear(0);

	quad.blend = 2;
	quad.tex = 0;
	
	int c = hgeColor(255.0/255.0,255.0/255.0,255.0/255.0,255.0/255.0).GetHWColor();
	//int c = hgeColor(10.0/255.0,20.0/255.0,112.0/255.0,255.0/255.0).GetHWColor();

	quad.v[0].x = 0;
	quad.v[0].y = 100;
	quad.v[0].z = 0;
	quad.v[0].col = c;

	quad.v[1].x = 0;
	quad.v[1].y = 500;
	quad.v[1].z = 0;
	quad.v[1].col = c;

	quad.v[2].x = 800;
	quad.v[2].y = 500;
	quad.v[2].z = 0;
	quad.v[2].col = c;

	quad.v[3].x = 800;
	quad.v[3].y = 100;
	quad.v[3].z = 0;
	quad.v[3].col = c;

	hge->Gfx_RenderQuad(&quad);




	
	TileMap->Draw(hge);
	P.Draw(hge,TileMap);


	string s;
	int minutes = 0;
	minutes = TotalTime/60000;
	int seconds = 0;
	seconds = (TotalTime - minutes*60000)/1000;
	if(minutes < 10)
	{
		s = itoa(0,buffer,10);
		s += itoa(minutes,buffer,10);
	}
	else
		s = itoa(minutes,buffer,10);
	s += ":";

	if(seconds < 10)
	{
		s += itoa(0,buffer,10);
		s += itoa(seconds,buffer,10);
	}
	else
		s += itoa(seconds,buffer,10);
	
	//height is 27
	int height = font->GetHeight();
	font->Render(20,20,s.c_str());
	
	
	

	minutes = 0;
	minutes = high_score/60000;
	seconds = 0;
	seconds = (high_score - minutes*60000)/1000;
	if(minutes < 10)
	{
		s = itoa(0,buffer,10);
		s += itoa(minutes,buffer,10);
	}
	else
		s = itoa(minutes,buffer,10);
	s += ":";

	if(seconds < 10)
	{
		s += itoa(0,buffer,10);
		s += itoa(seconds,buffer,10);
	}
	else
		s += itoa(seconds,buffer,10);

	font->Render(20,52,s.c_str());

	

	if(P.GetStatus() == false)
	{
		int width = font->GetStringWidth("Game Over");
		font->Render(400 - width/2,515,"Game Over");
		width = font->GetStringWidth("Press Enter To Begin A New Game");
		font->Render(400 - width/2,547,"Press Enter To Begin A New Game");
	}

	if(first_run == true)
	{
		int width = font->GetStringWidth("Press Enter To Begin A New Game");
		font->Render(400 - width/2,550 - 13,"Press Enter To Begin A New Game");
	}

	if(deathtime >= 1000)
	{
		float alpha = (livetime/1000.0)*255.0;
		c = hgeColor(255.0/255.0,255.0/255.0,255.0/255.0,alpha/255.0).GetHWColor();
	//int c = hgeColor(10.0/255.0,20.0/255.0,112.0/255.0,255.0/255.0).GetHWColor();

	quad.v[0].x = 0;
	quad.v[0].y = 100;
	quad.v[0].z = 0;
	quad.v[0].col = c;

	quad.v[1].x = 0;
	quad.v[1].y = 500;
	quad.v[1].z = 0;
	quad.v[1].col = c;

	quad.v[2].x = 800;
	quad.v[2].y = 500;
	quad.v[2].z = 0;
	quad.v[2].col = c;

	quad.v[3].x = 800;
	quad.v[3].y = 100;
	quad.v[3].z = 0;
	quad.v[3].col = c;

	hge->Gfx_RenderQuad(&quad);

	}



	hge->Gfx_EndScene();

	return false;
}


int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
	FMOD_RESULT result;
	


	result = FMOD::System_Create(&ssystem);		// Create the main system object.
	if (result != FMOD_OK)
	{
		return 1;
	}



	//result = ssystem->init(100, FMOD_INIT_NORMAL, 0);	// Initialize FMOD.
	//if (result != FMOD_OK)
	//{
	//	return 1;
	//}

	//err << "System_init" << endl;

	ssystem->setSpeakerMode(FMOD_SPEAKERMODE_STEREO);	// Set the output to 5.1.

	ssystem->setSoftwareChannels(50);		// Allow 100 software mixed voices to be audible at once.

	ssystem->setHardwareChannels(4, 32, 4, 32);	// Require the soundcard to have at least 32 2D and 3D hardware voices, and clamp it to using 64 if it has more than this.

	ssystem->init(100, FMOD_INIT_NORMAL, 0);		// Initialize FMOD with 200 virtual voices.

	FMOD::Sound *sound;
	ssystem->createSound("reaction song.mp3", FMOD_LOOP_NORMAL, 0, &sound);

	
	
	
	ssystem->playSound(FMOD_CHANNEL_FREE, sound, false, &channel);




  hge = hgeCreate(HGE_VERSION);
  hge->System_SetState(HGE_FRAMEFUNC, FrameFunc);
  hge->System_SetState(HGE_WINDOWED, true);
  hge->System_SetState(HGE_USESOUND, false);
  hge->System_SetState(HGE_TITLE, "Chain Reaction");
  hge->System_SetState((hgeState)14, 0xFACE0FF);
  
  if(hge->System_Initiate())
  {
	  srand(time(NULL));
	  file.open("score.txt");
	  file>>high_score_a;
	  file.close();
	  high_score = atoi(high_score_a);
		TileMap = new Map();
		TileMap->LoadSounds(ssystem);
		TileMap->AddPlayer(7, 2);
		font = new hgeFont("font1.fnt");
		TileMap->UpdateOff();
		
	  hge->System_Start();
  }
  else
  {	
	  MessageBoxA(NULL, hge->System_GetErrorMessage(), "Error",
		  MB_OK | MB_ICONERROR | MB_SYSTEMMODAL);
  }


  hge->System_Shutdown();
  hge->Release();

  ssystem->release();
  return 0;
}