#ifndef __MAP__
#define __MAP__

#include "hge.h"
#include "tile.h"
#include "fmod.hpp"

class Map{
public:
	Map();
	void Draw(HGE *hgep);
	void Update(float dt, FMOD::System *system, FMOD::Channel *channel);
	void GetTileState(float xp, float yp);
	void LoadSounds(FMOD::System *system);
	void AddPlayer(int pi, int pj);
	void MovePlayerRight(void);
	void MovePlayerLeft(void);
	void MovePlayerUp(void);
	void MovePlayerDown(void);
	void Stop(void){MovementRate = 0.0;};
	int GetPlayerTileState(void);
	float GetPlayerX(void);
	float GetPlayerY(void);
	float GetTempX(void);
	float GetTempY(void);
	void ExplodeAll(void);
	int GetPlayerCount(void);
	void Reset(void);
	void BombTest(void);
	void BombExplode(void);
	void DetonateBomb(void);
	void UpdateOn(void){update = true;};
	void UpdateOff(void){update = false;};

private:
	
	Tile *Tiles[55];

	void Move(float dt);
	void Propogate(float dt);
	void Regenerate(void);
	void UpdateTiles(float dt);
	void PlaySounds(FMOD::System *system, FMOD::Channel *channel);

	float LastPropogation;
	int explode_sound;
	float MovementRate;
	int bomb_explode_count;
	int elapsed_time;
	bool update;
	bool exploded;


	FMOD::Sound *sound0;
	FMOD::Sound *sound1;
	FMOD::Sound *sound2;
	FMOD::Sound *sound3;
	FMOD::Sound *sound4;
	FMOD::Sound *sound5;
	FMOD::Sound *sound6;
	FMOD::Sound *sound7;
	FMOD::Sound *sound8;
	FMOD::Sound *sound9;
	FMOD::Sound *sound10;

	FMOD::Channel *channel0;
	FMOD::Channel *channel1;
	FMOD::Channel *channel2;
	FMOD::Channel *channel3;
	FMOD::Channel *channel4;
	FMOD::Channel *channel5;
	FMOD::Channel *channel6;
	FMOD::Channel *channel7;
	FMOD::Channel *channel8;
	FMOD::Channel *channel9;
	FMOD::Channel *channel10;
};

#endif