#include "player.h"

Player::Player()
{
	MoveTimer = 0;
	alive = true;
	bombs = 3;
}

void Player::Draw(HGE *hgep, Map *TileMap)
{
	float alpha = 255.0;
	int color = hgeColor(255.0/255.0,128.0/255.0,0.0/255.0,alpha/255.0).GetHWColor();

	float x = TileMap->GetPlayerX();
	float y = TileMap->GetPlayerY();

	hgeQuad quad;
	quad.blend = 2;
	quad.tex = 0;

	quad.v[0].x = x - 40.05;
	quad.v[0].y = y - 40.05;
	quad.v[0].z = 0;
	quad.v[0].col = color;

	quad.v[1].x = x - 40.05;
	quad.v[1].y = y + 40.05;
	quad.v[1].z = 0;
	quad.v[1].col = color;

	quad.v[2].x = x + 40.05;
	quad.v[2].y = y + 40.05;
	quad.v[2].z = 0;
	quad.v[2].col = color;

	quad.v[3].x = x + 40.05;
	quad.v[3].y = y - 40.05;
	quad.v[3].z = 0;
	quad.v[3].col = color;

	if(alive == true)
		hgep->Gfx_RenderQuad(&quad);

	int bomb_position = 765;

	for(int b = 0; b < bombs; b++)
	{
		x = bomb_position;
		y = 50;

		int color = hgeColor(255.0/255.0,255.0/255.0,255.0/255.0,255.0/255.0).GetHWColor();

		quad.v[0].x = x - 10.05;
		quad.v[0].y = y - 10.05;
		quad.v[0].z = 0;
		quad.v[0].col = color;

		quad.v[1].x = x - 10.05;
		quad.v[1].y = y + 10.05;
		quad.v[1].z = 0;
		quad.v[1].col = color;

		quad.v[2].x = x + 10.05;
		quad.v[2].y = y + 10.05;
		quad.v[2].z = 0;
		quad.v[2].col = color;

		quad.v[3].x = x + 10.05;
		quad.v[3].y = y - 10.05;
		quad.v[3].z = 0;
		quad.v[3].col = color;

		bomb_position -= 30;

		hgep->Gfx_RenderQuad(&quad);
	}
}

void Player::GetInput(HGE *hgep, Map *TileMap, float dt)
{
	MoveTimer += dt;

	if(MoveTimer >= 100)
	{

		if(hgep->Input_GetKeyState(HGEK_D) || hgep->Input_GetKeyState(HGEK_RIGHT))
		{
			TileMap->MovePlayerRight();
		}
		if(hgep->Input_GetKeyState(HGEK_S) || hgep->Input_GetKeyState(HGEK_DOWN))
		{
			TileMap->MovePlayerDown();
		}
		if(hgep->Input_GetKeyState(HGEK_A) || hgep->Input_GetKeyState(HGEK_LEFT))
		{
			TileMap->MovePlayerLeft();
		}
		
		if(hgep->Input_GetKeyState(HGEK_W) || hgep->Input_GetKeyState(HGEK_UP))
		{
			TileMap->MovePlayerUp();
		}

		if(hgep->Input_GetKeyState(HGEK_SPACE))
		{
			if(bombs > 0)
			{
				TileMap->DetonateBomb();
				bombs--;
			}
		}
		

		MoveTimer = 0;

	}

}

void Player::Update(float dt, Map *TileMap)
{
	if(TileMap->GetPlayerTileState() == EXPLODING || TileMap->GetPlayerTileState() == BOMBEXPLODING || TileMap->GetPlayerTileState() == BOMB || TileMap->GetPlayerTileState() == ACTIVEBOMB || TileMap->GetPlayerTileState() == RESPAWNING)
	{
		alive = false;
		TileMap->ExplodeAll();
		TileMap->Stop();
	}

}