#ifndef __TILE__
#define __TILE__

#include "hge.h"
#include "hgecolor.h"
#include "math.h"

enum State{EXPLODING, EXPLODENEXT, RESPAWNING, NORMAL, ACTIVEBOMB, BOMB, BOMBEXPLODENEXT, BOMBEXPLODING};

class Tile{
public:
	void Draw(HGE *hgep);
	void DrawExploding(HGE *hgep);
	void SetPosition(float nx, float ny);
	Tile(void);
	Tile(float nx, float ny, int ncolor);
	void MoveLeft(float amount);
	float GetHorizontalPos(void);
	float GetVerticalPos(void){return y;};
	void SetHorizontalPos(float nx);
	void Reinitialize(float nx,int up, int down, int left, int right);
	void SetColor(int ncolor);
	int GetColor(void){return color_number;};
	void SetState(State s){TileState = s;};
	State GetState(void){return TileState;};
	void Update(float ndt);
	void SetScale(float nscale){scale = nscale;};
	void SetAlpha(float nalpha){alpha = nalpha;};
	float GetAlpha(void){return alpha;};
	float GetScale(void){return scale;};
	void SetPlayerStatus(bool p){hasPlayer = p;};
	bool GetPlayerStatus(void){return hasPlayer;};
	float GetBombTime(void){return bomb_time;};
	float GetElapsedTime(void){return elapsed_time;};
	void SetBombTime(float t){bomb_time = t;};
	void SetElapsedTime(float t){elapsed_time = t;};
	void Reset(void);
	void RegenOn(void){regen = true;};
	void RegenOff(void){regen = false;};
	

private:
	float x,y;
	int color;
	int color_number;
	hgeQuad quad;
	State TileState;
	float dt;
	float scale;
	float alpha;
	float elapsed_time;
	float bomb_time;
	bool hasPlayer;
	float piece_gen_percent;
	float bomb_percent;
	float active_bomb_percent;
	float elapsed_time2;
	bool regen;

};


#endif